<?php


namespace Drupal\custom_table_operations\Controller;

use Drupal\Core\Config\Entity\ConfigEntityListBuilder;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Url;
use Drupal\Core\Link;

/**
 * Provides a listing of DB tables
 */
class DbTableListBuilder extends ConfigEntityListBuilder{

    /**
     * {@inheritdoc}
     */
    public function buildHeader(){

        $header['label'] = $this->t('Table name');
        $header['id'] = $this->t('Machine name');
        $header['primary_key'] = $this->t('Primary key');

        return $header + parent::buildHeader();

    }

    /**
     * {@inheritdoc}
     */
    public function buildRow(EntityInterface $entity){

        $url = Url::fromRoute('entity.dbtable.content', ['dbtable' => $entity->label(), 'pk' => $entity->primary_key,], []);
        $row['label'] = (Link::fromTextAndUrl($entity->label(), $url));
        $row['id'] = $entity->id();
        $row['primary_key'] = $entity->primary_key;

        return $row + parent::buildRow($entity);
    }
}