<?php

namespace Drupal\custom_table_operations\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Database\Database;
use Drupal\Core\Url;
use Drupal\Core\Link;
use Drupal\Core\Messenger;
use Symfony\Component\HttpFoundation\JsonResponse;


/**
 * Provides a listing of DB tables records
 */
class TableContentController extends ControllerBase{

    /**
     * {@inheritdoc}
     */
    public function Listing($dbtable, $pk){

        $row = [];

        $entity = \Drupal::entityTypeManager()
                ->getStorage('dbtable')
                ->load($dbtable);
        $fields = $entity->field_list;


        $conn = Database::getConnection();
        $header = array();
        // $fields = $conn->query("DESCRIBE ".$dbtable)->fetchAll();
        // foreach($fields as $key=>$field){
        //     $header[$field->Field] = $field->Field;
        // }

        $table_key = [$pk => $pk];
        $opt = ['opt' => t('Operation')];
        $header = array_merge($table_key, $fields, $opt);

        $select_fields = array_merge($table_key, $fields);

        

        $query = $conn->select($dbtable, 'm');
        $query->fields('m', $select_fields );
        $result = $query->execute()->fetchAll();

        foreach($result as $value){
            $delete = Url::fromRoute('entity.dbtable.content_delete', ['dbtable' => $dbtable, 'pk' => $pk, 'cid' => $value->$pk], []);

            $edit = Url::fromRoute('entity.dbtable.content_edit_form', ['dbtable' => $dbtable, 'pk' => $pk, 'cid' => $value->$pk], []);

            $build_link_action = [
                'action_edit' => [
                    '#type' => 'html_tag',
                    '#value' => Link::fromTextAndUrl('Edit', $edit)->toString(),
                    '#tag' => 'div',
                    '#attributes' => ['class' => ['button button--small']]
                ],
                'action_delete' => [
                    '#type' => 'html_tag',
                    '#value' => Link::fromTextAndUrl('Delete', $delete)->toString(),
                    '#tag' => 'div',
                    '#attributes' => ['class' => ['button button--small button--danger']]
                ]
            ];

            $link_op = ['opt' => \Drupal::service('renderer')->render($build_link_action)];

            $row[] = array_merge((array)$value, $link_op);

        }

        $add = Url::fromRoute('entity.dbtable.content_add_form', ['dbtable' => $dbtable, 'pk' => $pk], []);

        $build_link_add = [
            
            'action_add' => [
                '#type' => 'html_tag',
                '#value' => Link::fromTextAndUrl('Add new record', $add)->toString(),
                '#tag' => 'div',
                '#attributes' => ['class' => ['button button--small']]
            ]
        ];

        $data['table'] = [
            '#type' => 'table',
            '#header' => $header,
            '#rows' => $row,
            '#empty' => t('Tables is empty!'),
            '#caption' => \Drupal::service('renderer')->render($build_link_add)
        ];

        return $data;
    }

    
}