<?php

namespace Drupal\custom_table_operations\Entity;


use Drupal\Core\Config\Entity\ConfigEntityBase;
use Drupal\custom_table_operations\CustomTableInterface;

/**
 * Defines the Custom table entity.
 *
 * @ConfigEntityType(
 *   id = "dbtable",
 *   label = @Translation("Custom Table"),
 *   handlers = {
 *     "list_builder" = "Drupal\custom_table_operations\Controller\DbTableListBuilder",
 *     "form" = {
 *       "add" = "Drupal\custom_table_operations\Form\DbTableForm",
 *       "edit" = "Drupal\custom_table_operations\Form\DbTableForm",
 *       "delete" = "Drupal\custom_table_operations\Form\DbTableDeleteForm",
 *     }
 *   },
 *   config_prefix = "dbtable",
 *   admin_permission = "administer site configuration",
 *   entity_keys = {
 *     "id" = "id",
 *     "label" = "label",
 *      "primary_key" = "Primary Key",
 *      "field_list" = "Field list",
 *   },
 *   config_export = {
 *     "id",
 *     "label",
 *      "primary_key",
 *      "field_list",
 *   },
 *   links = {
 *     "edit-form" = "/admin/config/system/dbtable/{dbtable}",
 *     "delete-form" = "/admin/config/system/dbtable/{dbtable}/delete",
 *   }
 * )
 */
class CustomTable extends ConfigEntityBase implements CustomTableInterface {

  /**
   * The Example ID.
   *
   * @var string
   */
  protected $id;

  /**
   * The Example label.
   *
   * @var string
   */
  protected $label;

  public $primary_key = array();

  public $field_list = array();


  // Your specific configuration property get/set methods go here,
  // implementing the interface.
}

