<?php

namespace Drupal\custom_table_operations\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\ConfirmFormBase;
use Drupal\Core\Url;
use Drupal\Core\Messenger;


/**
 * PUse to delete table records
 */
class TableContentDeleteForm extends ConfirmFormBase{

    public $cid;

    public function getformId(){
        return 'delete_form';
    }

    public function getQuestion(){
        return t('Are you sure to delete this record? This action cannot be undone.');
    }

    public function getCancelUrl(){

        $route = \Drupal::routeMatch();
        $table = $route->getParameter('dbtable');
        $pk = $route->getParameter('pk');

        return new Url('entity.dbtable.content', ['dbtable' => $table, 'pk' => $pk]);

    }

    public function getDescription(){

        return t('Are you sure?');
    }

    public function getConfirmText(){

        return t('Delete it');
    }

    public function getCancelText(){

        return t('Cancel');
    }

    public function submitForm(array &$form, FormStateInterface $form_state){

        $route = \Drupal::routeMatch();
        $table = $route->getParameter('dbtable');
        $pk = $route->getParameter('pk');
        $cid = $route->getParameter('cid');

        $query = \Drupal::database();
        if($query->delete($table)->condition($pk, $cid)->execute()){
            $this->messenger()->addMessage('Successfully deleted the record.');
        }else{
            $this->messenger()->addMessage('There is some error while deleting the record.', 'error');

        }

        $form_state->setRedirect('entity.dbtable.content', ['dbtable' => $table, 'pk' => $pk]);

    }
}